package be.cylab.java.wowa.training;

//import info.debatty.java.aggregation.WOWA;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class SolutionDistance implements Comparable<SolutionDistance> {

    public double[] weights_w;
    public double[] weights_p;
    private double distance = Double.POSITIVE_INFINITY;


    public SolutionDistance(int weights_number) {
        this.weights_w = new double[weights_number];
        this.weights_p = new double[weights_number];
    }
    @Override
    public String toString() {
        return "SolutionDistance{" +
                "weights_w=" + Arrays.toString(weights_w) +
                ", weights_p=" + Arrays.toString(weights_p) +
                ", distance=" + distance +
                '}';
    }

    public void computeScoreTo(List<double[]> data, double[] expected) {

        this.distance = Math.random();

    }


    public void randomlyMutateWithProbability(double probability) {
        double tos = Math.random();
        if (tos > probability) {
            // do nothing
            return;
        }

        //new weight value and position
        double new_weight_value = Math.random();
        int randomIndex = Utils.randomInteger(0, this.weights_p.length -1);
        //Select w or p weights
        int weight_selection = Utils.randomInteger(0, 1);
        if (weight_selection == 0) {
            this.weights_w[randomIndex] = new_weight_value;
        } else {
            this.weights_p[randomIndex] = new_weight_value;
        }
        this.normalize();

    }

    @Override
    public int compareTo(SolutionDistance solution) {
        return this.getDistance() > solution.getDistance() ? -1 : this.getDistance() < solution.getDistance() ? 1 : 0;
    }


    public void normalize() {
        this.weights_w = Utils.normalizeWeights(this.weights_w);
        this.weights_p = Utils.normalizeWeights(this.weights_p);
    }


    public double[] getWeights_w() {
        return weights_w;
    }

    public double[] getWeights_p() {
        return weights_p;
    }

    public double getDistance() {
        return distance;
    }

    public void setDistance(double distance) {
        this.distance = distance;
    }
}
