package be.cylab.java.wowa.training;

import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.List;
import java.util.Random;

public class Utils {

    public static double[] normalizeWeights(double[] weights) {
        double sum_weight = Utils.sumArrayElements(weights);
        double[] weightsNormalized = new double[weights.length];
        for (int i = 0; i < weights.length; i++) {
            weightsNormalized[i] = weights[i] / sum_weight;
        }
        return weightsNormalized;
    }

    public static double findMaxDistance(List<SolutionDistance> solutions) {
        double max = Double.NEGATIVE_INFINITY;
        for (SolutionDistance solution : solutions) {
            if(solution.getDistance() > max) {
                max = solution.getDistance();
            }
        }
        return max;
    }

    public static double findMinDistance(List<SolutionDistance> solutions) {
        double min = Double.POSITIVE_INFINITY;
        for (SolutionDistance solution : solutions) {
            if (solution.getDistance() < min){
                min = solution.getDistance();
            }
        }
        return min;
    }

    public static double sumTotalDistance(List<SolutionDistance> solutions) {
        double sum = 0;
        for (SolutionDistance solution : solutions) {
            sum += solution.getDistance();
        }
        return sum;
    }

    public static double sumArrayElements(double[] array) {
        float sum = 0;
        for (double weight : array) {
            sum += weight;
        }
        return sum;
    }

    public static int randomInteger(int min, int max) {
        if (min >= max) {
            throw new IllegalArgumentException("Max must be greater then min");
        }
        Random rnd = new Random();
        return rnd.nextInt((max - min) + 1) + min;
    }


}
